/**
* @file Arabic Unicode to CAL Code conversion
* @version 1.0.4
* @author Greg Borota
* @copyright (c) 2017 Greg Borota.
* @license MIT
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*/
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports,require("aramaic-mapper"),require("arabic-code-util"),require("cal-code-util")):"function"==typeof define&&define.amd?define(["exports","aramaic-mapper","arabic-code-util","cal-code-util"],t):t(e.arabicCal={},e.aramaicMapper,e.arabicCodeUtil,e.calCodeUtil)}(this,function(e,t,a,r){"use strict";var i=new t.Writing(a.allConsonants,a.vowels,a.diacritics,a.punctuation),c=Object.freeze(["t,","k,","d,","g,",")o"]),n=new t.Writing(Object.freeze(r.consonants.concat(["t,","k,","d,","d","z","g,","t",")",")o",")","w",")","y"])),Object.freeze(["a","o","i","u","a","i","u"]),Object.freeze(["","","","",""]),Object.freeze([";",";","?","!"])),o=function(e,t){return t[e]||(""===t[e]?"":e)},u=new t.Mapper(i,n,function(e,t,a,r){var i=e.charAt(t);if(!r.isDotted)return o(i,a);var c="",n=e.charAt(t+1);switch(i){case"َ":c="ا"===n&&e.length-1>t+1&&"-"!==e.charAt(t+2)?"(o":o(i,a);break;case"ِ":c="ي"===n?"yi":o(i,a);break;case"ُ":c="و"===n?"wu":o(i,a);break;default:c=o(i,a)}return c});u.multiples=c;e.mapper=u,e.toCal=function(e){var t=Object.freeze(Object.create(null,{isDotted:{value:a.isDotted(e),enumerable:!0}}));return u.map(e,t)},Object.defineProperty(e,"__esModule",{value:!0})});
